$(function () {
    window._bd_share_config = {
        common: {
            bdSnsKey: {},
            bdText: '',
            bdMini: '2',
            bdMiniList: !1,
            bdPic: '',
            bdStyle: '0',
            bdSize: '16',
            bdPopupOffsetLeft: -207
        },
        share: [
          {
              bdSize: 16
          }
        ]
    };
    with (document)
        (0)[
          ((getElementsByTagName('head')[0] || body).appendChild(
            createElement('script')
          ).src =
            '/statics/baidu/api/js/share.js')
        ];

    $('#toggle-share').click(function () {
        $(this).toggleClass('show-all');
        var w = $(this).hasClass('show-all') ? 228 : 140;
        $('#share-box')
          .stop()
          .animate({ width: w }, 'fast');
    });
    //通过cookie获取来源信息并且修改详情页咨询电话
    (function setPhone() {
        var makeVarKeyObj = function (key, val) {
            var ret = {};
            ret[key] = val;
            return ret;
        };
        var getCityNameById = function (cityId) {
            cityId = +cityId;

            for (var key in CITY_NAME_TO_ID) {
                if (CITY_NAME_TO_ID[key] === cityId) {
                    return key;
                }
            }
            return '';
        };
        var channelSourceSougou = encodeURIComponent('搜狗SEM丨PC'); //设置的奇葩url参数
        var channelSourceBaidu = encodeURIComponent('百度'); //百度渠道
        var channelSourceLine = encodeURIComponent('品牌起跑线'); //品牌起跑线
        var CITY_NAME_TO_ID = {
            chengdu: 278,
            wuhan: 209,
            hangzhou: 127,
            beijing: 38
        };
        var CHANNEL_SOURCE_PHONE_MAP = {
            chengdu: $.extend(
              {
                  '360': '4001187770-9114'
              },
              makeVarKeyObj(channelSourceBaidu, '4001187770-9113'),
              makeVarKeyObj(channelSourceSougou, '4001187770-9112'),
              makeVarKeyObj(channelSourceLine, '4001187770-9110')
            ),
            wuhan: $.extend(
              {
                  '360': '4001187770-9214'
              },
              makeVarKeyObj(channelSourceBaidu, '4001187770-9213'),
              makeVarKeyObj(channelSourceSougou, '4001187770-9212'),
              makeVarKeyObj(channelSourceLine, '4001187770-9210')
            ),
            beijing: $.extend(
              {
                  '360': '4001187770-9314'
              },
              makeVarKeyObj(channelSourceBaidu, '4001187770-9313'),
              makeVarKeyObj(channelSourceSougou, '4001187770-9312'),
              makeVarKeyObj(channelSourceLine, '4001187770-9310')
            ),
            hangzhou: $.extend(
              {
                  '360': '4001187770-9414'
              },
              makeVarKeyObj(channelSourceBaidu, '4001187770-9413'),
              makeVarKeyObj(channelSourceSougou, '4001187770-9412'),
              makeVarKeyObj(channelSourceLine, '4001187770-9410')
            )
        };

        function getCookie(name) {
            var arr,
              reg = new RegExp('(^| )' + name + '=([^;]*)(;|$)');
            if ((arr = document.cookie.match(reg))) {
                return arr[2];
            }
            return '';
        }
        function getQueryStr(str) {
            var _utm = decodeURIComponent(getCookie('_utm'));
            var ret = new RegExp(str + '=([^/&]*)', 'gi').exec(_utm);

            return ret ? ret[1] : '';
        }
        var phone;
        var channelSource = getQueryStr('utm_source');
        var cityId = getCookie('cityid');
        if (channelSource === '' || cityId === '') {
            return false;
        }
        var cityname = getCityNameById(cityId);
        channelSource = encodeURIComponent(channelSource);

        if (!CHANNEL_SOURCE_PHONE_MAP[cityname]) {
            return false;
        }
        phone = CHANNEL_SOURCE_PHONE_MAP[cityname][channelSource];
        $('.serve-phone, #fixed-nav-wrap b').text(phone);
    })();

    //房间选择按钮

    (function roomChoose() {
        var $priceClaim = $('#price-claim'); //显示的价格
        var $relLinks = $('[data-look-submit]');
        var $lookLink = $('#look-link'); //看房链接按钮
        var $roomReserve = $('.state-label', '#state-label-group').not('.disabled');
        var priceOld; //初始价格
        var linkOld = $lookLink.attr('href'); //看房按钮初始链接
        var $checked = $roomReserve.filter('.checked');
        var $orderNow = $('#order-now'); //立即预定提示

        if ($checked.length) {
            $priceClaim.html($checked.attr('data-price'));
            $relLinks.removeClass('disabled');
            $lookLink
              .attr('href', $checked.attr('data-look-link'))
              .removeClass('disabled');
        }

        $roomReserve.on('click', function () {
            var $me = $(this);
            $me.toggleClass('checked');
            priceOld = priceOld || $priceClaim.html();
            var $checkInDateDom = $('.check_in_date .detail-cont')
            if ($me.hasClass('checked')) {
                $me.siblings().removeClass('checked');
                $priceClaim.html($me.attr('data-price') || priceOld);
                $orderNow.addClass('active');
                $relLinks.removeClass('disabled');
                $lookLink
                  .attr('href', $me.attr('data-look-link') || linkOld)
                  .removeClass('disabled');
                var checkInDateStr = $me.data('check-in-date') && ('预计' + $me.data('check-in-date') + '可入住')
                checkInDateStr ? $('.check_in_date').show() : $('.check_in_date').hide()
                $checkInDateDom.text(checkInDateStr);
                var tenancyStr = $me.data('isShortRental')=="True" ? '可短租': '可长租'
                $('.tenancy .detail-cont').text(tenancyStr)
            } else {
                $('.check_in_date').hide()
                $priceClaim.html(priceOld);
                $orderNow.removeClass('active');
                $relLinks.addClass('disabled');
                $lookLink.attr('href', linkOld).addClass('disabled');
            }
        });
       
        
    })();

    //固定导航
    function makeFix($el) {
        var initT = $el.offset().top;
        $el.parent().css('height', $el.outerHeight());
        function calcTop() {
            var curTop =
              document.documentElement.scrollTop || document.body.scrollTop;

            if (curTop > initT) {
                $el.addClass('fixed');
                $el.trigger('nav-fixed');
            } else {
                $el.removeClass('fixed');
                $el.trigger('nav-fixed-cancel');
            }
        }
        calcTop();
        $(window).on('scroll', calcTop);
    }
    makeFix($('.js-fix-nav'));

    //侧边滚动标签
    (function fixSideLabel() {
        var $el = $('#detail-section-labels');
        var $fixedNavBox = $('#fixed-nav-wrap');
        var $box = $('#item-info-verbose');
        var $labels = $box.find('.icon-detail-tit-label');
        var labelNum = $labels.length;
        var offset = $fixedNavBox.outerHeight() + 1;
        var labelSize = $labels.first().height();
        var flag = false;
        var targets = [0];
        var old_i = 0;

        function getCurSt() {
            return document.documentElement.scrollTop || document.body.scrollTop;
        }

        function getCurIndex(targets) {
            var len = targets.length;
            var st = getCurSt();
            var i = 0;

            for (; i < len - 2; i++) {
                if (st >= targets[i] && st < targets[i + 1]) {
                    break;
                }
            }

            return i;
        }

        function showSideLabel(i) {
            $el
              .children()
              .removeClass('active')
              .slice(0, i)
              .addClass('active');
        }

        function init() {
            $fixedNavBox.on('nav-fixed', function () {
                flag = true;
                $el.addClass('active');
            });
            $fixedNavBox.on('nav-fixed-cancel', function () {
                flag = false;
                $el.removeClass('active');
                $labels.css('visibility', 'visible');
            });

            $el.css('top', offset + 10);
            $el.on('click', '.icon-detail-tit-label', function () {
                $('html,body').animate({ scrollTop: $(this).attr('data-pos') }, 'fast');
            });

            $labels.each(function (i) {
                var _offset = (i ? 10 + (labelSize + 10) * i : 10) + offset;
                var pos = $(this).offset().top - _offset;

                $(this).attr('data-pos', pos);
                targets.push(pos);
            });

            $el.empty().append($labels.clone());
            targets.push(Infinity);

            old_i = getCurIndex(targets);
            showSideLabel(old_i);
            if (old_i > 0) {
                flag = true;
                $el.addClass('active');
            }

            $(window).on('scroll', function () {
                if (!flag) {
                    return;
                }

                var i = getCurIndex(targets);

                if (i - old_i < 0) {
                    //up
                    showSideLabel(i);
                    $labels.eq(Math.min(i, labelNum - 1)).css('visibility', 'visible');
                } else if (i - old_i > 0) {
                    //down
                    $labels.eq(i - 1).css('visibility', 'hidden');
                    showSideLabel(i);
                }
                old_i = i;
            });
        }

        $(window).on('load', function () {
            init();
        });
    })();

    //监视滚动条位置  动态更新导航样式
    function spyNav($nav, offset) {
        offset = offset || 0;
        var $navs = $nav.find('li>a');
        var $li = $nav.find('li');
        var targets = [];

        $navs.each(function () {
            var href = $(this).attr('href');
            var $href = /#\w+/.test(href) && $(href);

            $href && targets.push([$href.offset().top, this]);
        });

        if (!targets.length) {
            return;
        }

        $(window).on('scroll', function () {
            var st = document.documentElement.scrollTop || document.body.scrollTop;
            st = st + offset;
            var len = targets.length;
            var i = len - 1;

            for (; i >= 0; i--) {
                if (st > targets[len - 1][0]) {
                    break;
                }
                if (
                  st > targets[i][0] &&
                  (!targets[i + 1] || st <= targets[i + 1][0])
                ) {
                    break;
                }
            }
            i = i < 0 ? 0 : i;

            $li.removeClass('active');
            $(targets[i][1])
              .parent()
              .addClass('active');
        });
    }
    spyNav($('#fixed-nav'), 100);

    //未选择房间提示框
    var infoPop = {
        init: function ($el) {
            $el = typeof $el === 'string' ? $($el) : $el;
            this.$el = $el;
            var me = this;
            var $dismiss = $el.find('[data-dismiss]');
            $dismiss.on('click', function () {
                me.hide();
            });
            $el.on('click', function (e) {
                if ($(e.target).is(this)) {
                    me.hide();
                }
            });

            return this;
        },
        show: function () {
            this.$el.show();
        },
        hide: function () {
            this.$el.hide();
        }
    };
    var noneChooseInfo = infoPop.init('#info-pop');

    //图片浏览
    function imgViewer($box, thumbNum) {
        var $bigImgs = $box.find('.img-viewer-bg li');
        var $thumbnails = $box.find('.img-viewer-list li');
        var len = $thumbnails.length;
        var $btnNext = $box.find('.viewer-next');
        var $btnPrev = $box.find('.viewer-prev');
        var $firstThumb = $thumbnails.eq(0);
        var w = $firstThumb.width();

        thumbNum = thumbNum || 6;

        function showByIndex(index) {
            var $indexImg = $bigImgs.eq(index).find('img');

            if (!$indexImg.hasClass('loaded')) {
                var img = new Image();
                var src = $indexImg.attr('data-source');
                img.src = src;

                img.onload = function () {
                    $indexImg.attr('src', src);
                    $indexImg.addClass('loaded');
                };
            }
            $thumbnails
              .eq(index)
              .addClass('cur')
              .siblings()
              .removeClass('cur');
            $bigImgs
              .filter('.cur')
              .fadeOut('fast')
              .removeClass('cur')
              .end()
              .eq(index)
              .addClass('cur')
              .fadeIn('fast');
        }
        function moveList(index, dir) {
            var ml = parseInt($firstThumb.css('marginLeft'));

            if (len <= thumbNum) {
                return;
            }

            if (index === 0 || index === len - 1) {
                $firstThumb.animate({ marginLeft: -w * index }, 'fast');
                return;
            }
            var opt = dir === 1 ? '-' : '+';

            if ((ml >= 0 && dir === -1) || (ml <= -w * (len - 1) && dir === 1)) {
                return;
            }

            $firstThumb.animate({ marginLeft: opt + '=' + w }, 'fast');
        }
        $thumbnails.on('click', function () {
            var $me = $(this);
            var index = $me.index();

            if ($me.hasClass('cur')) {
                return;
            }

            showByIndex(index);
        });

        $btnPrev.on('click', function () {
            var $cur = $thumbnails.filter('.cur');
            var index = $cur.index();

            index = index === 0 ? len - 1 : --index;

            showByIndex(index);
            moveList(index, -1);
        });
        $btnNext.on('click', function () {
            var $cur = $thumbnails.filter('.cur');
            var index = $cur.index();

            index = index === len - 1 ? 0 : ++index;

            showByIndex(index);
            moveList(index, 1);
        });

        showByIndex(0);
    }
    imgViewer($('.js-img-viewer'));

    $('.img-viewer-bg').magnificPopup({
        delegate: 'a',
        type: 'image',
        tLoading: '图片加载中...',
        mainClass: 'mfp-img-mobile',
        gallery: {
            enabled: !0,
            navigateByImgClick: !0,
            preload: [0, 1]
        },
        image: {
            tError: '该图未能正常读取...',
            titleSrc: function (b) {
                return b.el.attr('title') + '<small>商业盗图要遭剁手-优客逸家</small>';
            }
        }
    });
    $('.js-img-popup').magnificPopup({
        type: 'image',
        image: {
            tError: '该图未能正常读取...',
            titleSrc: function (b) {
                return b.el.attr('title') + '<small>商业盗图要遭剁手-优客逸家</small>';
            }
        }
    });
    //powerTip插件
    $('.has-tips').powerTip({ placement: 'n', fadeInTime: 0 });

    /*地图*/
    //读取坐标
    var location = (function () {
        var locData = $('#locationData')
          .val()
          .split(',');

        var lng = locData.length && locData[0];
        var lat = locData.length && locData[1];

        return {
            lng: lng,
            lat: lat
        };
    })();

    var itemMap = null; //房源地理位置的实例;
    var local = null; //localsearch 服务
    var bounds = null; //地图边界;
    var drivingSearch = null; //驾车搜索;
    var itemPoint = null; //房源坐标Point类;
    var itemMarker = null; //房源坐overlay;
    var itemTransfer = null; //公交策略搜索;
    var sourrDingSearch = null; //周边搜索；
    var policyMap = {
        least_time: BMAP_TRANSIT_POLICY_LEAST_TIME,
        avoid_subway: BMAP_TRANSIT_POLICY_AVOID_SUBWAYS,
        least_walking: BMAP_TRANSIT_POLICY_LEAST_WALKING,
        least_transfer: BMAP_TRANSIT_POLICY_LEAST_TRANSFER
    };

    function initMap(container, loc, desc) {
        if (!loc) {
            return false;
        }

        if (isNaN(loc.lng) || isNaN(loc.lat) || !loc.lng || !loc.lat) {
            var city = new BMap.LocalCity();
            var geo = new BMap.Geocoder();

            city.get(function (r) {
                geo.getPoint(
                  desc,
                  function (point) {
                      if (point) {
                          itemPoint = point;
                          itemMap = new BMap.Map(container);
                          itemMap.centerAndZoom(point, 16);
                          itemMap.enableScrollWheelZoom();

                          itemMarker = new BMap.Marker(point);
                          itemMap.addOverlay(itemMarker);
                          itemMarker.setAnimation(BMAP_ANIMATION_BOUNCE);
                      } else {
                          throw new Error('地址解析失败,请传入正确的经纬度');
                      }
                  },
                  r.name
                );
            });
        } else {
            itemMap = new BMap.Map(container);
            itemPoint = new BMap.Point(loc.lng, loc.lat);
            itemMap.centerAndZoom(itemPoint, 15);
            itemMap.enableScrollWheelZoom();

            itemMarker = new BMap.Marker(itemPoint);
            itemMap.addOverlay(itemMarker);
            itemMarker.setAnimation(BMAP_ANIMATION_BOUNCE);
        }
    }

    //显示地图

    initMap('map-wrap', location, $('#loc-name').html());
    //关键词搜索
    $('#map-nav').on('click', 'a', function () {
        var keyword = $(this).attr('data-keyword');

        $(this)
          .addClass('active')
          .siblings()
          .removeClass('active');
        if (!local && itemMap) {
            local = new BMap.LocalSearch(itemMap, {
                renderOptions: { map: itemMap, autoViewport: false }
            });
        }
        if (itemMap.current_state !== 'serviceSearch') {
            itemMap.centerAndZoom(itemPoint, 16);
            itemMap.clearOverlays();
            itemMap.addOverlay(itemMarker);
            itemMarker.setAnimation(BMAP_ANIMATION_BOUNCE);

            itemMap.current_state = 'serviceSearch';
        }
        bounds = itemMap.getBounds();
        local.searchInBounds(keyword, bounds);
    });
    //搜索框,获取出租车费用，触发策略搜索
    $('#local-search-form').on('submit', function (e) {
        e.preventDefault();
        var $searchInput = $('#search-ipt');
        var val = $searchInput.val();

        if (!drivingSearch && itemMap) {
            drivingSearch = new BMap.DrivingRoute(itemMap, {
                onSearchComplete: function (r) {
                    if (!r || !r.taxiFare) {
                        $searchInput.addClass('error').val('请输入精准有效的描述');
                        return;
                    }
                    $('#filter-tags')
                      .addClass('active')
                      .find('.active')
                      .trigger('click');
                    // $('#fee-num').html(r.taxiFare.day.totalFare + '元');
                },
                renderOptions: { map: itemMap, autoViewport: true }
            });
        }
        if (itemMap.current_state !== 'routeSearch') {
            itemMap.clearOverlays();
            itemMap.current_state = 'routeSearch';
        }

        drivingSearch.search(itemPoint, val);
    });
    //策略切换
    $('#filter-tags').on('click', 'a', function () {
        var $me = $(this);
        var policy = policyMap[$me.attr('data-policy')];
        var $searchInput = $('#search-ipt');
        var val = $searchInput.val();

        $me
          .addClass('active')
          .siblings()
          .removeClass('active');

        if (!itemTransfer && itemMap) {
            itemTransfer = new BMap.TransitRoute(itemMap, {
                renderOptions: { map: itemMap },
                onSearchComplete: function (r) {
                    if (itemTransfer.getStatus() == BMAP_STATUS_SUCCESS) {
                        var len = r.getNumPlans();
                        var str = '';
                        for (var i = 0; i < len; i++) {
                            str +=
                              '<div class="result-item">' +
                              '<div class="item-label">' +
                              '推荐路线' +
                              (i + 1) +
                              '<span>(' +
                              r.getPlan(i).getDistance(true) +
                              r.getPlan(i).getDuration(true) +
                              ')</span></div>' +
                              '<div class="item-desc">' +
                              r.getPlan(i).getDescription() +
                              '</div>' +
                              '</div>';
                        }

                        $('#map-search-result').html(str);
                    } else {
                        $searchInput.addClass('error').val('请输入精准有效的描述');
                    }
                }
            });
        }
        if (itemMap.current_state !== 'transferSearch') {
            itemMap.clearOverlays();
            itemMap.current_state = 'transferSearch';
        }
        itemTransfer.setPolicy(policy);
        itemTransfer.search(itemPoint, val);
    });

    $('#search-ipt').focus(function () {
        var $me = $(this);

        if ($me.hasClass('error')) {
            $me.removeClass('error');
            $me.val('');
        }
    });

    //回到当前位置；
    $('#goBack').click(function () {
        if (itemMap) {
            itemMap.reset();
        }
    });

    //周边配套信息；
    !(function () {
        if (itemMap && itemPoint) {
            var keyWords = ['地铁站', '公交', '餐饮', '购物'];
            sourrDingSearch = new BMap.LocalSearch(itemPoint, {
                onSearchComplete: function (allData) {
                    var resultsList = $('#surroundMatch div:odd');
                    $.each(allData, function (index, data) {
                        var result = [];
                        var len = data.getNumPois();
                        var item;
                        if (len != 0) {
                            for (var i = 0; i < len; i++) {
                                item = data.getPoi(i);
                                if ((data.keyword === '公交' && i !== 0) || !item) {
                                    continue;
                                }
                                if (data.keyword === '公交') {
                                    result.push(item.title + '：' + item.address);
                                } else {
                                    result.push(item.title);
                                }
                            }
                            result = result.join('、').replace(/;/g, '、');
                        }
                        $(resultsList[index]).text(result.length ? result : '暂无');
                    });
                },
                pageCapacity: 5
            });
            var bounds = itemMap.getBounds();
            sourrDingSearch.searchInBounds(keyWords, bounds);
        }
    })();

    //RegionalMatchInfo();
    /**
       * 选择默认房间
       */
    var roomCode = $('#roomCode').val();
    var $roomReserve = $('.state-label', '#state-label-group').not('.disabled');
    if (roomCode) {
        var roomDoms = $("div.state-label[data-roomcode='" + roomCode + "']").not(
          '.disabled'
        );
        if (roomDoms.length > 0) {
            roomDoms.eq(0).click();
        } else {
            $('#roomCode').val('');
        }
    }else{
        console.log($roomReserve)
        $roomReserve.eq(0).trigger('click')
    }

    $('[data-look-submit]').click(function () {
        var $me = $(this);
        if ($me.hasClass('disabled')) {
            noneChooseInfo.show();
            return false;
        }
    });

    $('#look-link-old').on('click', function () {
        if ($(this).hasClass('disabled')) {
            return;
        }
        $.modal.show('#order-modal');
    });

    $('#reserveRoom').click(function () {
        var $btn = $('#reserveRoom');
        var $selected = $('.state-label', '#state-label-group')
          .not('.disabled')
          .filter('.checked');
        if ($selected.length) {
            $("#reserveForm input[name='roomid']").val($selected.attr('data-roomid'));
            //$("#reserveForm input[name='roomcode']").val($(".detail-num").text() + $selected.attr("data-roomcode"));
            //$("#reserveForm input[name='roomdescription']").val($selected.text());
        }


        var form = $('#reserveForm');
        form.validation();
        if (form.valid() == 0) return false;
        $btn.attr({'disabled': 'disabled'});
        $btn.val('提交中...');
        $.ajax({
            type: 'post',
            url: '/api/room/reservation',
            data: form.serialize(),
            error: function (jqXHR, textStatus, errorThrown) {
                alert(jqXHR.responseText.length == 0 ? "提交预约信息失败, 请稍后再试! " : JSON.parse(jqXHR.responseText).Message);
                $btn.removeAttr('disabled');
                $btn.val('提交');
            },
            success: function (data) {    
                $btn.removeAttr('disabled');
                $btn.val('提交');
                if (data == false) {
                    alert("提交预约信息失败, 请稍后再试! ");
                } else {
                    $('.select_call_name').text(
                      $("#reserveForm input[name='name']").val() +
                        ($("#reserveForm input[name='gender']:checked").val() == 0
                          ? ' 先生'
                          : ' 女士')
                    );
                    $.modal.hide();
                    $.modal.show('#order-modal-callback');
                }
            }
        });
    });
});
